' check_jre.vbs, ABr, 19-APR-13
' Checks JRE on a Windows box and pulls down from common location / silent install.

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Globals
g_sNotFound = "***NOPE***"
g_sJavaRegWow6432 = "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\JavaSoft\Java Runtime Environment"
g_sJavaRegDirect = "HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Runtime Environment"
g_sNetJreLocation = "\\172.24.0.33\AnonRead\JRE"
g_sRefJreVerFile = "winver.txt"
g_sRefKeyVersion = "RefVer"
g_sRefKey32bit = "32bit"
g_sRefKey64bit = "64bit"
g_messageString = ""

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Functions

' is string NULL or Zero or Empty?
Function isBlank(Value)
	'returns True if Empty or NULL or Zero
	If IsEmpty(Value) or IsNull(Value) Then
	 isBlank = True
	 Exit Function
	ElseIf VarType(Value) = vbString Then
	 If Value = "" Then
	  isBlank = True
	  Exit Function
	 End If
	ElseIf IsObject(Value) Then
	 If Value Is Nothing Then
	  isBlank = True
	  Exit Function
	 End If
	ElseIf IsNumeric(Value) Then
	 If Value = 0 Then
	  wscript.echo " Zero value found"
	  isBlank = True
	  Exit Function
	 End If
	Else
	 isBlank = False
	End If
End Function

' detect OS type (32-bit or 64-bit)
Function isOs32()
  Dim sAddressWidth
  sAddressWidth = GetObject("winmgmts:root\cimv2:Win32_Processor='cpu0'").AddressWidth
  If sAddressWidth = "64" Then
    isOs32 = False
  Else
    isOs32 = True
  End If
End Function

' write program output
Function writeOutput(sMsg)
  Dim d, s

  ' format date
  d = Now()
  s = Year(d) & "-" & Right("00" & Month(d), 2) & "-" & Right("00" & Day(d), 2) _
    & " " & Right("00" & Hour(d), 2) & ":" & Right("00" & Minute(d), 2) & ":" & Right("00" & Second(d), 2)

  WScript.Echo s & " " & sMsg
End Function

' read from Windows Registry
Function readFromRegistry (strRegistryKey, strDefault )
  Dim WSHShell, value

  On Error Resume Next
  Set WSHShell = CreateObject("WScript.Shell")
  value = WSHShell.RegRead( strRegistryKey )
  If err.number <> 0 Then
    readFromRegistry= strDefault
  Else
    readFromRegistry=value
  End If
  Set WSHShell = Nothing
End Function

' detect the JRE path in Windows Registry
Function getJreRegPath()
  Dim str, sQuery

  ' 6432 check first
  sQuery = g_sJavaRegWow6432 & "\CurrentVersion"
  str = readFromRegistry(sQuery, g_sNotFound)
  If str = g_sNotFound Then
    ' direct check
    sQuery = g_sJavaRegDirect & "\CurrentVersion"
    str = readFromRegistry(sQuery, g_sNotFound)
    If str = g_sNotFound Then
      ' not found, get out
      getJreRegPath = g_sNotFound
    Else
      getJreRegPath = g_sJavaRegDirect
    End If
  Else
    getJreRegPath = g_sJavaRegWow6432
  End If
End Function

' is JRE installed?
Function isJreInstalled()
  Dim str
  str = getJreRegPath()
  If str = g_sNotFound Then
    isJreInstalled = False
  Else
    isJreInstalled = True
  End If
End Function

' what is JRE version?
Function getJreVersion()
  Dim sRegPath, sCurrentVersion, sJavaFamily, sActualVersion

  ' registry path
  sRegPath = getJreRegPath()

  ' current java version...family only
  sCurrentVersion = readFromRegistry(sRegPath & "\CurrentVersion", g_sNotFound)

  ' get family
  sJavaFamily = Right(sCurrentVersion, 1)

  ' read the actual version
  sActualVersion = readFromRegistry(sRegPath & "\Java" & sJavaFamily & "FamilyVersion", g_sNotFound)
  getJreVersion = sActualVersion
End Function

' is this a 32-bit JRE?
Function isJre32()
  Dim sRegPath, sCurrentVersion, sJavaFamily, sActualVersion

  ' registry path
  sRegPath = getJreRegPath()

  ' check for cross install (32-bit on 64-bit system)
  If sRegPath = g_sJavaRegWow6432 Then
    ' yup, 32-bit JRE installed on 64-bit system. this is expected.
    isJre32 = True
    Exit Function
  End If

  ' it's a straight install, so check the OS type
  isJre32 = isOs32()
End Function

'Trova il path su disco della JRE installata
Function getJavaHome()
	Dim sRegPath, sCurrentVersion, sJavaFamily, sActualVersion

  ' registry path
  sRegPath = getJreRegPath()

  ' current java version...family only
  sCurrentVersion = readFromRegistry(sRegPath & "\CurrentVersion", g_sNotFound)
  
  ' java home
  getJavaHome = readFromRegistry(sRegPath & "\" & sCurrentVersion & "\JavaHome", g_sNotFound)
end Function

Function removeJavatwainFiles(jreHomePath)
	Dim libPath
	libPath = jreHomePath & "\lib\ext\"
	deleteFile( libPath & "javatwain.jar" )
	deleteFile( libPath & "javatwain_license.jar" )
	deleteFile( libPath & "tiff_lite.jar" )
	deleteFile( libPath & "x86\javatwain.dll" )
end Function

Function deleteFile(fileName)
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	if objFSO.fileExists( libPath & fileName) then
		objFSO.DeleteFile(libPath & fileName)
		g_messageString = g_messageString & "il file " & fileName & " e' stato rimosso" & vbCrLf
	else
		g_messageString = g_messageString & "il file " & fileName & " non esiste" & vbCrLf
	end if
end Function
' exit the program
Function doExit(sExitMsg)
  If Not isBlank(sExitMsg) Then
    writeOutput(sExitMsg)
  End If
  if ( g_messageString <> "" ) then
	writeOutput( g_messageString )
  end if
  'WScript.Quit
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' BEGIN MAIN PROGRAM

' preamble
'writeOutput("removeJavatwain.vbs: BEGIN")
If Not isJreInstalled() Then doExit("Nessuna JRE installata")

' check installed version
sJreVersion = getJreVersion()
bJreIs32 = isJre32()
If bJreIs32 Then sJreArch = "32-bit" Else sJreArch = "64-bit"
removeJavatwainFiles( getJavaHome())
doExit("Processo completato")